(*****************************************************************************
:         u_TileIteratorWideSpiralByRect
:    SASPlaneta
:       
:        Dima2000
:       v5
:         11.05.2012

     ,   
        .       
u_TileIteratorSpiralByRect   .

           
(.Create    .Next)  .        , 
            ""  
        .  ,      
.    (4:3)  .

         (TRect)  1*1  .
          (  100*2)    
  ,         
.     .

******************************************************************************
 :
v5      11.05.2012
[*]    ITileIterator.

v4      11.05.2012
[*]   box    -     
      .
[*]     box -    .

v3      06.05.2012
[+]        .   
          .

v2      06.05.2012
[+]    .   -  .
[*]     5       .

v1      03.05.2012
[+]  ,    .

******************************************************************************
ToDo:
+1.    ,   .
+2.           .  
          .
+3.   TTileIteratorByRectBase,   ITileIterator.

PS.        11*9 :
81_82_83_84_85_86_87_88_89_90_91
80_49_50_51_52_53_54_55_56_57_92
79_48_25_26_27_28_29_30_31_58_93
78_47_24_09_10_11_12_13_32_59_94
77_46_23_08_02_01_03_14_33_60_95
76_45_22_07_06_05_04_15_34_61_96
75_44_21_20_19_18_17_16_35_62_97
74_43_42_41_40_39_38_37_36_63_98
73_72_71_70_69_68_67_66_65_64_99
      3-   ,    
 ---  ..

*****************************************************************************)
unit u_TileIteratorWideSpiralByRect;

interface

uses
  Types,
  i_TileIterator;

type
  TTileIteratorWideSpiralByRect = class(TInterfacedObject, ITileIterator)
  private
    { }
    fBox: TRect;
    { }
    fCenter: TPoint;
    { }
    fCurrent: TPoint;
    {  }
    fDelta: TPoint;
    {   }
    fMax: integer;
    {  }
    fSquare: boolean;
    fCount, fSize: integer;
    fNc, fN, fN0: integer;
    {    }
    function Step: TPoint;
    {     fBox}
    function CheckPoint(const t: TPoint): integer;
    {     fBox}
    function GetTilesTotal: int64;
    {  box}
    function GetTilesRect: TRect;
  public
    {    ,   ( ).
       ,      
        -    .
    N -    N- , N0 -    N0- .
    : N -  , N0 -    [1..N].
            }
    constructor Create(const rect: TRect; const Square: boolean = false; const N: integer=1; const N0: integer=1);
    {  ,  }
    procedure Reset;
    {       }
    function Next(out Tile: TPoint): boolean;
    {    }
    property TilesTotal: int64 read GetTilesTotal;
    { }
    property TilesRect: TRect read GetTilesRect;
    { }
    property Center: TPoint read fCenter;
    property Square: boolean read fSquare;
  end;


implementation


{     fBox}
function TTileIteratorWideSpiralByRect.GetTilesTotal: int64;
begin
  Result := int64(fBox.Right - fBox.Left) * int64(fBox.Bottom - fBox.Top);
end;


{  box}
function TTileIteratorWideSpiralByRect.GetTilesRect: TRect;
begin
  Result := fBox;
end;


{     fBox}
function TTileIteratorWideSpiralByRect.CheckPoint(const t: TPoint): integer;
{ 1    fBox}
{ -1    fBox }
{ 0      fBox,      
  fBox,    }
begin
  Result := 1;
  if t.X <  fBox.Left   then Result := 0;
  if t.X >= fBox.Right  then Result := 0;
  if t.Y <  fBox.Top    then Result := 0;
  if t.Y >= fBox.Bottom then Result := 0;
  if fSize > fMax + 2   then Result := -1; {    fBox}
end;


{    }
function TTileIteratorWideSpiralByRect.Step: TPoint;
begin
  case fSize of
  -2: fCurrent := Point(fCenter.X + 0, fCenter.Y + 0);
  -1: fCurrent := Point(fCenter.X - 1, fCenter.Y + 0);
  0:  fCurrent := Point(fCenter.X + 1, fCenter.Y + 0);
  else
    {    }
    Inc(fCurrent.X, fDelta.X);
    Inc(fCurrent.Y, fDelta.Y);
    {     }
    Dec(fCount);
    {   ,       }
    if fCount = 0 then begin
      fCount := fSize;
      if fDelta.Y = 0 then begin
        fDelta.Y := fDelta.X;
        fDelta.X := 0;
        if fSquare then Inc(fSize);
      end
      else begin
        fDelta.X := -fDelta.Y;
        fDelta.Y := 0;
        if not fSquare then begin
          Inc(fSize);
          Inc(fCount, 2);
        end;
      end;
    end;
  end;
  {          case }
  if fSize < 1 then Inc(fSize);
  Result := fCurrent;
end;


{  ,  }
procedure TTileIteratorWideSpiralByRect.Reset;
begin
  fNc := fN0;
  if fSquare then begin
    fSize := 1;
    fCount := 2;
    fDelta := Point(+1, 0);
    fCurrent := Point(fCenter.X - 1, fCenter.Y);
  end
  else begin
    fSize := -2;
    fCount := 1;
    fDelta := Point(0, +1);
  end;
end;


{    ,   ( )
   ,      
    -    
N -    N- , N0 -    N0- .
: N -  , N0 -    [1..N].
        }
constructor TTileIteratorWideSpiralByRect.Create(const rect: TRect; const Square: boolean = false; const N: integer=1; const N0: integer=1);
var
  {  }
  sh, sv: integer;
begin
  fSquare := Square;
  fBox := rect;
  {   ,   }
  fN0 := N0;
  {   ,    }
  fN := N;
  sh := fBox.Right - fBox.Left;
  sv := fBox.Bottom - fBox.Top;
  {     }
  if sv > sh then fMax := sv
  else            fMax := sh;
  {      5-    .
     ,     .}
  if (sh < 5) or (sv < 5) or (sh = sv) then fSquare := true;
  fCenter.X := (fBox.Left + fBox.Right - 2) div 2;
  fCenter.Y := (fBox.Top + fBox.Bottom - 2) div 2;
  {   ,  }
  Reset;
end;


{       }
function TTileIteratorWideSpiralByRect.Next(out Tile: TPoint): boolean;
var
  res, i: integer;
begin
  Result := false;
  {    ,     }
  if fNc < 1 then Exit;
  {    -fNc- }
  for i := 1 to fNc do begin
    repeat
      {   }
      Tile := Step;
      {  }
      res := CheckPoint(Tile);
      if res < 0 then Exit; {   }
    {    }
    until res <> 0;
  end;
  {        }
  fNc := fN;
  Result := true;
end;


end.
